1000 :
1010 REMark **********************************************************************
1020 REMark *    The following three lines instruct Turbo how to compile EX6     *
1030 REMark **********************************************************************
1040 :
1050 TURBO_objfil 'ram1_EX6_TASK':TURBO_taskn 'EX6 v2.2':TURBO_objdat 100
1060 TURBO_repfil 'ram1_err':TURBO_struct 1:TURBO_windo 0:TURBO_buffersz 300
1070 TURBO_model '<':TURBO_struct 's'
1080 :
1090 REMark **********************************************************************
1100 REMark *         MANIFEST sets constants, not variables, for speed          *
1110 REMark **********************************************************************
1120 :
1130 MANIFEST: ws_citem=$30:ws_cibrw=$32:ws_cipap=$34:ws_cihit=$38
1140 MANIFEST: ws_ptpos=$20:Move_Win=$F5:ESC=27
1150 :
1160 REMark EX6_bas v2.2
1170 REMark 9 DEC 02
1180 :
1190 IF COMPILED:OPEN#0,con:INK#0,GREEN%:wch%=100:ELSE :BOUTL:wch%=0
1200 :
1210 REMark **********************************************************************
1220 REMark *                  wch% is used by M_SETUP                           *
1230 REMark *           wch% is 100 if compiled and 0 otherwise                  *
1240 REMark **********************************************************************
1250 :
1260 IF NOT Set_Win:PRINT#0,"I can't open my windows!":Stip
1270 :
1280 REMark **********************************************************************
1290 REMark * Set_Win sets the entire window definition from DATA lines @ 19600  *
1300 REMark * and sets wd(r), the address(es) of window definition(s)            *
1310 REMark **********************************************************************
1320 :
1330 REMark                            *******************************************
1340 wwd=M_SETUP(#wch%,wd(0),0):REMark *    To produce the working definition    *
1350 REMark                            *******************************************
1360 :
1370 IF COMPILED:chid=M_PRPOS(wwd,-1):ELSE :chid=M_PULLD(wwd,-1)
1380 :
1390 REMark **********************************************************************
1400 REMark *       We must set a primary window here if this is COMPILED.       *
1410 REMark *          (PRPOS can be thought of as PRimary POSitioned).          *
1420 REMark *      If this is not COMPILED, BOUTL has set #0 as primary, so      *
1430 REMark *         the window here must instead be "pulled down" as a         *
1440 REMark *                       secondary window.                            *
1450 REMark **********************************************************************
1460 :
1470 REMark         **************************************************************
1480 Set_Col:REMark *                   setup colours                            *
1490 REMark         **************************************************************
1500 :
1510 REMark **********************************************************************
1520 REMark *         This is the repeat loop for reading the pointer and        *
1530 REMark *          taking apropriate action using WRPTRT not WRPTR.          *
1540 REMark *                                                                    *
1550 REMark * "lad" is the address of the loose item list.                       *
1560 REMark * "stad" is the address of the status area.                          *
1570 REMark * "no_li%" is the number of loose items - if none STOP.              *
1580 REMark *                                                                    *
1590 REMark * The reason for using WRPTRT is to make use of its timeout          *
1600 REMark * facility to cause signalling of the purpose of each loose item.    *
1610 REMark **********************************************************************
1620 :
1630 lad=PEEK_L(wwd+$6A):stad=PEEK_L(wwd)
1640 no_li%=PEEK_W(wwd+$68):IF no_li%=0:finish
1650 DIM li_set%(no_li%)
1660  REPeat lp
1670   k=WRPTRT(wwd,100,0)
1680   REMark pos1=BRPTR(11,pos,wwd,100-101*(cite%<0))
1690   r=255&&get_x%(k)
1700   SELect ON r
1710    =255:REMark loose items
1720     IF do_loose%(get_y%(k)):EXIT lp
1730    =254:REMark event
1740     IF do_event%(get_y%(k)):EXIT lp
1750    =252:REMark Timed out
1760     IF Exp_Winds:EXIT lp
1770   END SELect
1780  END REPeat lp
1790 finish
1800 :
1810 DEFine FuNction do_loose%(num%)
1820  REMark routine to do loose items
1830  LOCal k,ans%
1840  k=num%:ans%=0
1850  REMark ********************************************
1860  REMark * There are 3 loose items, numbered 0 to 2 *
1870  REMark * 0 = the move icon                        *
1880  REMark * 1 = "ESC"                                *
1890  REMark * 2 = Action                               *
1900  REMark ********************************************
1910  SELect ON k
1920   =1:ans%=1
1930   =0:mve1
1940   =2:Col_Alt
1950  END SELect
1960                             REMark **********************************
1970  D_LDRW num%,wwd:           REMark * Resets the item to "available" *
1980                             REMark **********************************
1990  RETurn ans%
2000 END DEFine
2010 :
2020 DEFine FuNction do_event%(num%)
2030  REMark ***********************************
2040  REMark *    Each of these two  events    *
2050  REMark *  can also be accessed via the   *
2060  REMark *     appropriate loose item      *
2070  REMark *     2 = quit and 8 = move       *
2080  REMark *  When the action is done this   *
2090  REMark * returns 1 for stop, 0 for go on *
2100  REMark ***********************************
2110  LOCal as%
2120  as%=0
2130  IF 2&&num%:finish:as%=1
2140  IF 8&&num%:mve1
2150  RETurn as%
2160 END DEFine
2170 :
2180 :
2190 REMark **********************************************************************
2200 REMark * Do_Indic pulls down and services the indicating window specific to *
2210 REMark *  loose item number ite%. Each window contains a note of what the   *
2220 REMark *   item does. Each of these windows has an invisible sprite whose   *
2230 REMark *    movement will cause the window to disappear, as will any key    *
2240 REMark *                             press.                                 *
2250 REMark *                                                                    *
2260 REMark * When Do_Indic completes, the pointer is set to its original place  *
2270 REMark * in the main window. Also acty is set if a key requiring action was *
2280 REMark *                            pressed.                                *
2290 REMark **********************************************************************
2300 :
2310 REMark **********************************************************************
2320 REMark *   A key/mouse press has occurred so appropriate action is taken.   *
2330 REMark **********************************************************************
2340 :
2350 :
2360 :
2370 REMark **********************************************************************
2380 REMark * Given a hit or a do Do_Action decides what action to take, if any. *
2390 REMark * ite% < 1 when the pointer is not on any loose item and is the item *
2400 REMark * number otherwise (1, 2 etc). so 1 -> move, 2 -> Exit, 3 -> Action  *
2410 REMark **********************************************************************
2420 :
2430 DEFine FuNction Do_Action
2440  REMark returns 1 if end, else 0
2450  LOCal x,ans
2460  x=ite%-1:ans=0
2470  SELect ON x
2480   =0:mve1
2490   =1:ans=1
2500   =2:Col_Alt
2510  END SELect
2520  RETurn ans
2530 END DEFine
2540 :
2550 REMark **********************************************************************
2560 REMark * The indicating secondary windows disappear on the movememnt of the *
2570 REMark * pointer or on any key/mouse press. It is the job of Do_Action1 to  *
2580 REMark * translate a key/mouse press into appropriate action. ESC action is *
2590 REMark *   indicated by returning 1. Other actions are performed and 0 is   *
2600 REMark *          returned so that the program can continue.                *
2610 REMark *  The value of key/mouse press (acty) was taken directly from the   *
2620 REMark *   status area of working definition wwd1. Note that this is the    *
2630 REMark *        working definition of the small indicating window,          *
2640 REMark *                          not the main one                          *
2650 REMark **********************************************************************
2660 :
2670 DEFine FuNction Do_Action1
2680  LOCal ans,x
2690  ans=0
2700  SELect ON acty
2710   =1,2:ans=Do_Action
2720   =ESC:ans=1
2730   =CODE("A"),CODE('a'):Col_Alt
2740   =Move_Win:mve1
2750  END SELect
2760  RETurn ans
2770 END DEFine
2780 :
2790 DEFine PROCedure Set_Col:            REMark *********************************
2800  DIM colv%(5):                       REMark * The values of 6 colours are   *
2810  colv%(0)=L_RED%:colv%(1)=D_RED%:    REMark * stored in colv%. The initial  *
2820  colv%(2)=L_GREEN%:colv%(3)=D_GREEN%:REMark * value of the colour pointer   *
2830  colv%(4)=MUSTARD%:colv%(5)=GREY%:   REMark *    col_no% is 1 - D_RED%      *
2840  col_no%=1:                          REMark *********************************
2850 END DEFine
2860 :
2870 REMark **********************************************************************
2880 REMark *   Exp_Winds finds whether the pointer is in a hit area or not.     *
2890 REMark *  If so it sets an indicating window and prodesses it, returning 1  *
2900 REMark *            if ESC was actioned, and 0 otherwise.                   *
2910 REMark *    If the pointer was not in a hit area no action is taken.        *
2920 REMark **********************************************************************
2930 :
2940 DEFine FuNction Exp_Winds
2950  IF PEEK_W(stad+12)<>-1:RETurn 0
2960  ite%=PEEK_W(stad+$30):IF ite%<0:RETurn 0
2970  ite%=ite%+1
2980  acty=Do_Indic:IF acty:RETurn Do_Action1:ELSE :RETurn 0
2990 END DEFine
3000 :
3010 DEFine FuNction Do_Sec
3020 :                                REMark *************************************
3030  LOCal pos1,pos2,x:              REMark *   -Indicator Window Program-      *
3040  pos1=BRPTR(48,0,wwd1):          REMark *  pos1 = current pointer position  *
3050  pos2=BRPTR(11,pos1,wwd1):       REMark * wait till move or key/mouse press *
3060  IF pos1<>pos2:RETurn -1:        REMark *    If move just close window      *
3070  x=PEEK(PEEK_L(wwd1)+$12):       REMark *         x = key pressed           *
3080  SELect ON x
3090             :                    REMark * If hit, do, A/a or ESC do it . .  *
3100   =1,2,ESC,Move_Win,CODE("A"),CODE('a'):acty=x
3110   =REMAINDER :acty=-1:           REMark *   . . else just close window      *
3120 :                                REMark *************************************
3130  END SELect
3140  RETurn acty
3150 END DEFine :                     REMark *************************************
3160 :
3170 DEFine PROCedure finish
3180  PRINT#0,"ENDED":BUNST wwd:BRCHP wwd:CLOS chid
3190  BRECHP:STOP
3200 END DEFine
3210 :
3220 DEFine PROCedure mve1:            REMark ************************************
3230  BCHWIN wwd:                      REMark *          Move the window         *
3240 END DEFine :                      REMark ************************************
3250 :
3260 REMark **********************************************************************
3270 REMark * Do_Indic pulls down and services the indicating window specific to *
3280 REMark *  loose item number ite%. Each window contains a note of what the   *
3290 REMark *   item does. Each of these windows has an invisible sprite whose   *
3300 REMark *    movement will cause the window to disappear, as will any key    *
3310 REMark *                             press.                                 *
3320 REMark *                                                                    *
3330 REMark * When Do_Indic completes, the pointer is set to its original place  *
3340 REMark * in the main window. Also Do_Indic returns the keypress causing the *
3350 REMark *              indicating window to cease, or -1.                    *
3360 REMark **********************************************************************
3370 :
3380 DEFine FuNction Do_Indic
3390  LOCal kyp
3400                                  REMark *************************************
3410  wwd1=M_SETUP(#0,wd(ite%),-1) :  REMark *   Set the working definition.     *
3420  chid1=M_PULLD(wwd1,-1):         REMark *     Make the window appear.       *
3430  kyp=Do_Sec:                     REMark *  Process this window until . .    *
3440  BUNST wwd1:                     REMark *    . .  it disappears . .         *
3450  CLOS chid1:                     REMark * . . and its channel is closed.    *
3460  BRCHP wwd1:                     REMark *  Returns the space for working    *
3470                                  REMark *    definition to the heap.        *
3480  RETurn kyp:                     REMark *    Return the keypress or -1      *
3490                                  REMark *************************************
3500 :
3510 END DEFine
3520 :
3530 DEFine PROCedure Col_Alt:      REMark ***************************************
3540  col_no%=(col_no%+1) MOD 5:    REMark * Set the next colour number . .      *
3550  POKE_W wwd+$2E,colv%(col_no%):REMark * . . to the working definition       *
3560  BWRSET wwd:                   REMark *       Redraw the window             *
3570 END DEFine :                   REMark ***************************************
3580 :
19600 DATA 2008
19601 DATA 37,17747,17162,16739,29801,28526,2637,28534
19602 DATA 25866,17784,26996,2627,26721,28263,25971,8259
19603 DATA 28524,28533,29194,2565,11781,9733,10240,256
19604 DATA 1540,-14847,0,0,4096,3328,1024,256
19605 DATA 0,3072,0,15360,0,27648,0,12
19606 DATA 3072,12,3072,12,3072,13,3456,-32691
19607 DATA 19888,-20371,28084,-19347,28084,-19345,28668,-897
19608 DATA 32764,-961,16380,-961,16376,-2017,8176,-4084
19609 DATA 3072,30,7680,30,7680,31,8064,-32673
19610 DATA 24544,-7937,-4,-769,-2,-257,-2,-257
19611 DATA -2,-257,-2,-385,32766,-385,32764,-961
19612 DATA 16376,-2047,256,0,8192,3328,1024,256
19613 DATA 0,3072,0,28672,0,-11264,0,0
19614 DATA 0,0,160,-4096,0,0,160,-4096
19615 DATA 0,0,160,-4096,0,0,162,-3200
19616 DATA -16384,32,12450,-3190,-12544,40,15522,-3190
19617 DATA -12512,12328,15522,-3190,-12512,12328,15530,-86
19618 DATA -96,-4054,16298,-86,-96,-4086,4010,-86
19619 DATA -96,-4086,4010,-86,-128,-16382,938,-86
19620 DATA -256,0,240,-4096,0,3,1020,-1024
19621 DATA 0,3,1020,-1024,0,3,1023,-64
19622 DATA -16384,51,13311,-4,-1024,255,-1,-1
19623 DATA -16,-3841,-1,-1,-4,-769,-1,-1
19624 DATA -4,-769,-1,-1,-4,-769,-1,-1
19625 DATA -4,-961,16383,-1,-4,-961,16383,-1
19626 DATA -16,-4081,4095,-1,-64,-16382,8448,0
19627 DATA 3840,3328,1024,256,0,3072,1,-22528
19628 DATA 0,0,0,0,0,0,0,0
19629 DATA 0,0,0,0,0,0,0,0
19630 DATA 0,0,0,0,0,255,-257,-512
19631 DATA 0,0,0,0,0,0,0,0
19632 DATA 0,0,0,0,0,255,-257,-512
19633 DATA 0,0,0,0,0,0,0,0
19634 DATA 0,0,0,0,0,255,-257,-512
19635 DATA 0,0,0,0,0,0,0,0
19636 DATA 0,0,0,0,0,255,-257,-512
19637 DATA 255,-257,-512,0,0,0,0,0
19638 DATA 0,0,255,-512,0,255,-257,-512
19639 DATA 255,-257,-512,255,-257,-512,0,0
19640 DATA 0,0,255,-257,-512,255,-257,-512
19641 DATA 255,-257,-512,255,-257,-512,255,-512
19642 DATA 0,0,255,-257,-512,255,-257,-512
19643 DATA 255,-257,-512,255,-257,-512,255,-512
19644 DATA 0,0,255,-257,-512,255,-257,-257
19645 DATA -257,-257,-257,-257,-257,-257,-257,-512
19646 DATA 0,0,255,-257,-257,-257,-257,-257
19647 DATA -257,-257,-257,-257,-257,-257,-257,-512
19648 DATA 0,0,0,255,-257,-257,-257,-257
19649 DATA -257,-257,-257,-257,-257,-257,-257,-512
19650 DATA 0,0,0,255,-257,-257,-257,-257
19651 DATA -257,-257,-257,-257,-257,-257,-512,0
19652 DATA 0,0,0,0,255,-257,-257,-257
19653 DATA -257,-257,-257,-257,-257,-512,0,0
19654 DATA 0,0,0,0,0,255,-1,-256
19655 DATA 0,0,0,0,0,0,0,0
19656 DATA 0,0,0,0,255,-1,-1,-1
19657 DATA -256,0,0,0,0,0,0,0
19658 DATA 0,0,0,0,255,-1,-1,-1
19659 DATA -256,0,0,0,0,0,0,0
19660 DATA 0,0,0,0,255,-1,-1,-1
19661 DATA -1,-1,-256,0,0,0,0,0
19662 DATA 0,0,255,-256,255,-1,-1,-1
19663 DATA -1,-1,-1,-1,-256,0,0,0
19664 DATA 0,255,-1,-1,-1,-1,-1,-1
19665 DATA -1,-1,-1,-1,-1,-1,-1,-256
19666 DATA 0,255,-1,-1,-1,-1,-1,-1
19667 DATA -1,-1,-1,-1,-1,-1,-1,-1
19668 DATA -256,255,-1,-1,-1,-1,-1,-1
19669 DATA -1,-1,-1,-1,-1,-1,-1,-1
19670 DATA -256,255,-1,-1,-1,-1,-1,-1
19671 DATA -1,-1,-1,-1,-1,-1,-1,-1
19672 DATA -256,255,-1,-1,-1,-1,-1,-1
19673 DATA -1,-1,-1,-1,-1,-1,-1,-1
19674 DATA -256,0,255,-1,-1,-1,-1,-1
19675 DATA -1,-1,-1,-1,-1,-1,-1,-1
19676 DATA -256,0,255,-1,-1,-1,-1,-1
19677 DATA -1,-1,-1,-1,-1,-1,-1,-256
19678 DATA 0,0,0,255,-1,-1,-1,-1
19679 DATA -1,-1,-1,-1,-1,-1,-256,0
19680 DATA 0,1,0,0,512,256,0,0
19681 DATA 0,3072,0,3072,0,3072,0,0
19682 DATA 0,1,256,0,1024,256,0,0
19683 DATA 0,3072,0,3072,0,3072,0,0
19684 DATA 0,2,8448,0,512,256,0,0
19685 DATA 0,3072,0,3072,0,0,0,0
19686 DATA 0,255,-1,-255,5939,2609,2605,12554
19687 DATA 12850,13322,14641,2609,12810,12593,2609,2609
19688 DATA 2612,2610,12592,2608,2609,2608,2615,2612
19689 DATA 2605,12554,11569,2615,2608,2605,12554,11569
19690 DATA 2608,2615,2605,12554,11569,2610,12852,2617
19691 DATA 12554,12598,13112,13322,12594,2608,2605,12554
19692 DATA 13618,2609,13322,13322,12810,12298,12554,12298
19693 DATA 13322,12554,12298,12298,12298,12298,11569,2605
19694 DATA 12554,12298,12298,11569,2605,12554,12298,12298
19695 DATA 11569,2605,12554,13618,2609,13322,12298,11569
19696 DATA 2613,12810,12596,2612,2610,2608,2609,2608
19697 DATA 2612,2609,2608,2608,2608,2608,2605,12554
19698 DATA 11569,2608,2608,2605,12554,11569,2608,2608
19699 DATA 2605,12554,11569,2613,12810,12596,2608,2605
19700 DATA 12554,12599,12810,12596,2612,2610,2608,2609
19701 DATA 2608,2612,2609,2608,2608,2608,2608,2605
19702 DATA 12554,11569,2608,2608,2605,12554,11569,2608
19703 DATA 2608,2605,12554,11569,2609,14130,2609,13322
19704 DATA 67,11569,2605,12554,12298,13618,2609,13322
19705 DATA 12298,12298,12298,12298,13322,13322,12298,13618
19706 DATA 2609,13322,12298,12298,12298,12298,13322,13322
19707 DATA 12298,12599,12810,12596,2608,2608,2608,2608
19708 DATA 2612,2612,2560,-22478,2612,12298,12848,2610
19709 DATA 2609,2608,2608,2610,2613,2608,2612,12298
19710 DATA 12848,2609,14386,2609,2608,2608,2608,2611
19711 DATA 2609,2609,13110,2610,12298,13364,2609,2608
19712 DATA 2608,2605,12554,13877,2610,2609,2608,2609
19713 DATA 2608,2605,14090,11569,2605,12554,12298,12598
19714 DATA 13360,13322,12594,2608,2608,2608,2608,2608
19715 DATA 2608,2608,2608,2608,2605,12554,11569,2605
19716 DATA 12554,11569,2605,12554,11569,2605,12554,11569
19717 DATA 2605,12554,11569,2605,12554,11569,2605,12554
19718 DATA 11569,2605,12554,11569,2605,12554,11569,2560
19719 DATA 24112,2612,14346,12592,2610,2609,2608,2613
19720 DATA 12594,2608,2610,2605,12554,11569,2605,12554
19721 DATA 12298,13368,2609,12298,12810,12554,12298,13617
19722 DATA 12810,12298,13066,11569,2605,12554,11569,2608
19723 DATA 2609,13880,2609,12298,12810,12554,12298,13617
19724 DATA 12810,12298,13322,11569,2605,12554,11569,2560
19725 DATA 3885,12554,11569,2605,12554,11569,2605,12554
19726 DATA 0,0,0,0
19727 DATA 49641
