1000 :
1010 REMark *************************************************************
1020 REMark * The following two lines instruct Turbo how to compile EX7 *
1030 REMark *************************************************************
1040 :
1050 TURBO_objfil 'ram1_EX7_TASK':TURBO_taskn 'Ex7 v1.1':TURBO_objdat 100
1060 TURBO_repfil 'ram1_err':TURBO_struct 1:TURBO_windo 0:TURBO_buffersz 300
1070 :
1080 REMark Ex7_bas v1.1
1090 REMark 5 FEB 02
1100 :
1110 IF MODE%=8:MODE 4
1120 IF COMPILED:OPEN#0,con:INK#0,GREEN%:wch%=100:ELSE :BOUTL:wch%=0
1130 :
1140 REMark **************************************
1150 REMark * wch% is used by M_SETUP, see later *
1160 REMark **************************************
1170 :
1180 IF NOT Set_Win:PRINT#0,"I can't open my windows!":Stip
1190 :
1200 REMark **********************************************************************
1210 REMark * Set_Win sets the entire window definition from DATA lines @ 19600  *
1220 REMark * and sets wd(r), the address(es) of window definition(s)            *
1230 REMark **********************************************************************
1240 :
1250 REMark                            **************************************
1260 wwd=M_SETUP(#wch%,wd(0),0):REMark * To produce the working definition  *
1270 REMark                            **************************************
1280 IF COMPILED:chid=M_PRPOS(wwd,-1):ELSE :chid=M_PULLD(wwd,-1)
1290 REMark ************************************************************
1300 REMark * We must set a primary window here if this is COMPILED .  *
1310 REMark * (PRPOS can be thought of as PRimary POSitioned)          *
1320 REMark * If this is not COMPILED, BOUTL has set #0 as primary, so *
1330 REMark * the window here must instead be "pulled down".           *
1340 REMark ************************************************************
1350 :
1360 REMark *******************************************************
1370 REMark * This is the repeat loop for reading the pointer and *
1380 REMark * taking appropriate action                           *
1390 REMark *******************************************************
1400 :
1410 REPeat lp
1420  k=WRPTR(wwd):REMark k indicates whether loose item, event or application
1430  r=255&&get_x%(k)
1440  SELect ON r
1450   =255:REMark loose items
1460     IF do_loose%(get_y%(k)):EXIT lp
1470   =254:REMark event
1480     IF do_event%(get_y%(k)):EXIT lp
1490   =REMAINDER :REMark application window k
1500     do_app r,get_y%(k)
1510  END SELect
1520 END REPeat lp
1530 STOP
1540 :
1550 DEFine PROCedure finish
1560  BUNST wwd:CLOS chid:REMark *  the window is removed *
1570  BRECHP:REMark *  all ALCHPd space returned to the heap *
1580 END DEFine
1590 :
1600 DEFine FuNction do_loose%(num)
1610  REMark *********************************************
1620  REMark * routine to do loose items                 *
1630  REMark * this returns 1 for "finished" else 0      *
1640  REMark * the three loose items are 0 = move sprite *
1650  REMark *                           1 = ESC         *
1660  REMark *                           2 = Second      *
1670  REMark *********************************************
1680  LOCal ov%,nym
1690  ov%=0:nym=num:REMark Don't use parameter for SELect
1700  SELect ON nym
1710   =1:finish:ov%=1
1720   =0:mve1
1730  REMark *********************************************
1740  REMark *  D_LDRW  2 sets loose item 2 to available *
1750  REMark *********************************************
1760 :
1770   =2:new_win:D_LDRW 2,wwd
1780 :
1790   =REMAINDER :ov%=1
1800  END SELect
1810  RETurn ov%
1820 END DEFine
1830 :
1840 DEFine FuNction do_event%(num%)
1850  REMark carry out event
1860  REMark only move and escape
1870  LOCal ov%
1880  ov%=0
1890  IF 2&&num%:finish:ov%=1
1900  IF 8&&num%:mve1
1910  RETurn ov%
1920 END DEFine
1930 :
1940 DEFine PROCedure do_app(wind%,num%)
1950  REMark *********************************
1960  REMark * to do the menu item no num%   *
1970  REMark * in window number wind%        *
1980  REMark * no action need be taken here  *
1990  REMark *********************************
2000 :
2010 END DEFine
2020 :
2030 DEFine PROCedure mve1
2040  REMark to move window
2050  BCHWIN wwd
2060  D_LDRW 0,wwd
2070 END DEFine
2080 :
2090 DEFine PROCedure new_win
2100 :
2110  REMark ****************************************
2120  REMark * to pull down a secondary window . .  *
2130  REMark * . . whose wdef is wd(1)              *
2140  REMark ****************************************
2150 :
2160                            REMark *********************************************
2170  wwd1=M_SETUP(#0,wd(1),-1):REMark * Set the working definition.               *
2180  chid1=M_PULLD(wwd1,-1):   REMark * Make the window appear.                   *
2190  do_sec:                   REMark * Process this window until . .             *
2200  BUNST wwd1:               REMark * it disappears . .                         *
2210  CLOS chid1:               REMark * . . and its channel is closed.            *
2220  BRCHP wwd1:               REMark * Returns the space for working definition. *
2230                            REMark *********************************************
2240 :
2250 END DEFine
2260 :
2270 DEFine PROCedure do_sec
2280  LOCal lp
2290  REPeat lp
2300   k=WRPTR(wwd1):REMark k indicates whether loose item, event or application
2310   r=255&&get_x%(k)
2320   SELect ON r
2330    =255:REMark loose items
2340      IF do_loose1%(get_y%(k)):EXIT lp
2350    =REMAINDER :REMark application window k
2360      do_app r,get_y%(k)
2370   END SELect
2380  END REPeat lp
2390 END DEFine
2400 :
2410 DEFine FuNction do_loose1%(num)
2420  LOCal ov%,nym
2430  nym=num:ov%=0
2440  SELect ON nym
2450   =0:mve2
2460   =1:do_size
2470   =2:ov%=1:D_LDRW 2,wwd1
2480  END SELect
2490  RETurn ov%
2500 END DEFine
2510 :
2520 DEFine PROCedure mve2
2530  REMark to move window
2540  BCHWIN wwd1
2550  D_LDRW 0,wwd1
2560 END DEFine
2570 :
2580 DEFine PROCedure do_size
2590  LOCal mv,xmv%,ymv%,newx%,newy%,optr
2600  REMark ************************************************
2610  REMark * optr is the value to be used for PRPOS/PULLD *
2620  REMark * It is the current window position plus its   *
2630  REMark * "origin" plus its height. This will keep the *
2640  REMark * bottom left of the window in the same place  *
2650  REMark * as far as possible, since the new height     *
2660  REMark * will be subtracted later at M_PULLD.         *
2670  REMark * The current position's at $24 of the working *
2680  REMark * definition (wwd), and the "origin" at the    *
2690  REMark * long word at byte 4 of the window definition *
2700  REMark * whose address is given in both wd(0) and     *
2710  REMark * PEEK_L(wwd+4).                               *
2720  REMark ************************************************
2730  optr=PEEK_L(wwd1+$24)+PEEK_L(wd(1)+4)+PEEK_W(wwd1+$22)
2740                 REMark *********************************
2750  mv=BCHSZ(wwd1):REMark * mv is the change in size      *
2760                 REMark *********************************
2770  xmv%=-get_x%(mv):ymv%=get_y%(mv)
2780  REMark *************************************************
2790  REMark * We now have to check that the new size is     *
2800  REMark * within reasonable limits. It must be no       *
2810  REMark * bigger than the maximum in the window         *
2820  REMark * definition. It must be no smaller than the    *
2830  REMark * minimum size for this window layout.          *
2840  REMark * This size is used in M_SETUP to arrive at the *
2850  REMark * actual size.                                  *
2860  REMark * PEEK_L(wwd+32) is the current window size.    *
2870  REMark * PEEK_L(wd(0)+$30) is the minimum size for the *
2880  REMark * first window layout. Since this is variable   *
2890  REMark * we must eliminate the scaling flag ($4000)    *
2900  REMark * for both x and y values.                      *
2910  REMark * PEEK_L(PEEK_L(wwd+4)) is the maximum size of  *
2920  REMark * window.                                       *
2930  REMark * Finally newx% must be made even (by ev%).     *
2940  REMark *************************************************
2950 :
2960  newx%=ev%(min%(PEEK_W(PEEK_L(wwd1+4)),max%(PEEK_W(wd(1)+48)&&4095,PEEK_W(wwd1+32)-xmv%)))
2970  newy%=min%(PEEK_W(PEEK_L(wwd1+4)+2),max%(PEEK_W(wd(1)+50)&&4095,PEEK_W(wwd1+34)-ymv%))
2980 :
2990  REMark *****************************************************
3000  REMark * BUNST unsets the working definition and throws    *
3010  REMark * away the window if NOT COMPILED.                  *
3020  REMark * BRCHP returns its area to the heap.               *
3030  REMark * CLOS closes the channel opened.                   *
3040  REMark * M_SETUP sets up the new working definition and    *
3050  REMark * gives us its address (in wwd).                    *
3060  REMark * M_PRPOS throws away the old window and sets up    *
3070  REMark * a new one. M_PULLD pulls down a secondary window. *
3080  REMark * All that remains is to reset #4, find the limits  *
3090  REMark * to this window via set_lim and to set on/off to   *
3100  REMark * OFF just as for a window move.                    *
3110  REMark *****************************************************
3120  BUNST wwd1:BRCHP wwd1:CLOS chid1
3130  wwd1=M_SETUP(#0,wd(1),newx%*2^16+newy%)
3140  chid1=M_PULLD(wwd1,optr-newy%)
3150   D_LDRW 1,wwd1
3160 END DEFine
3170 :
3180 REMark ********************************************************
3190 REMark * The following DATA lines contain all the             *
3200 REMark * information needed to set up the windows in EX1.     *
3210 REMark * This includes the window sizes, the colours, and     *
3220 REMark * sprites wanted. It also contains the sprites, blobs, *
3230 REMark * or patterns themselves. All this is unravelled and   *
3240 REMark * set in the window definitions by Set_Win.            *
3250 REMark ********************************************************
3260 :
19600 DATA 2475
19601 DATA 12,17747,17162,21349,25455,28260,2570,2054
19602 DATA 2046,2048,1,6,1222,256,0,16
19603 DATA 13,4,1,0,12,0,60,0
19604 DATA 108,0,0,3084,0,3084,0,3084
19605 DATA 0,3341,-32640,19789,-20304,28013,-19276,28013
19606 DATA -19276,28527,-772,32639,-772,16191,-772,16191
19607 DATA -1800,7967,-3856,3084,0,7710,0,7710
19608 DATA 0,7967,-32640,24415,-7968,-1,-772,-1
19609 DATA -258,-1,-258,-1,-258,-1,-258,32639
19610 DATA -258,32639,-772,16191,-1800,257,0,32
19611 DATA 13,4,1,0,12,0,112,0
19612 DATA 212,0,0,0,0,0,-24336,0
19613 DATA 0,0,-24336,0,0,0,-24336,0
19614 DATA 0,0,-23821,-32576,0,8240,-23821,-30001
19615 DATA 0,10300,-23821,-30001,8240,10300,-23821,-30001
19616 DATA 8240,10300,-21761,-21761,-24336,10815,-21761,-21761
19617 DATA -24336,2575,-21761,-21761,-24336,2575,-21761,-21761
19618 DATA -32576,515,-21761,-21761,0,0,-3856,0
19619 DATA 0,771,-772,0,0,771,-772,0
19620 DATA 0,771,-1,-16192,0,13107,-1,-772
19621 DATA 0,-1,-1,-1,-3856,-1,-1,-1
19622 DATA -772,-1,-1,-1,-772,-1,-1,-1
19623 DATA -772,-1,-1,-1,-772,16191,-1,-1
19624 DATA -772,16191,-1,-1,-3856,3855,-1,-1
19625 DATA -16192,545,0,15,13,4,1,0
19626 DATA 12,0,424,0,0,0,0,0
19627 DATA 0,0,0,0,0,0,0,0
19628 DATA 0,0,0,0,0,0,0,0
19629 DATA 0,-2,-2,0,0,0,0,0
19630 DATA 0,0,0,0,0,0,0,0
19631 DATA 0,-2,-2,0,0,0,0,0
19632 DATA 0,0,0,0,0,0,0,0
19633 DATA 0,-2,-2,0,0,0,0,0
19634 DATA 0,0,0,0,0,0,0,0
19635 DATA 0,-2,-2,0,-2,-2,0,0
19636 DATA 0,0,0,0,0,0,-2,0
19637 DATA 0,-2,-2,0,-2,-2,0,-2
19638 DATA -2,0,0,0,0,0,-2,-2
19639 DATA 0,-2,-2,0,-2,-2,0,-2
19640 DATA -2,0,-2,0,0,0,-2,-2
19641 DATA 0,-2,-2,0,-2,-2,0,-2
19642 DATA -2,0,-2,0,0,0,-2,-2
19643 DATA 0,-2,-2,-2,-2,-2,-2,-2
19644 DATA -2,-2,-2,0,0,0,-2,-2
19645 DATA -2,-2,-2,-2,-2,-2,-2,-2
19646 DATA -2,-2,-2,0,0,0,0,-2
19647 DATA -2,-2,-2,-2,-2,-2,-2,-2
19648 DATA -2,-2,-2,0,0,0,0,-2
19649 DATA -2,-2,-2,-2,-2,-2,-2,-2
19650 DATA -2,-2,0,0,0,0,0,0
19651 DATA -2,-2,-2,-2,-2,-2,-2,-2
19652 DATA -2,0,0,0,0,0,0,0
19653 DATA 0,-1,-1,0,0,0,0,0
19654 DATA 0,0,0,0,0,0,0,0
19655 DATA -1,-1,-1,-1,0,0,0,0
19656 DATA 0,0,0,0,0,0,0,0
19657 DATA -1,-1,-1,-1,0,0,0,0
19658 DATA 0,0,0,0,0,0,0,0
19659 DATA -1,-1,-1,-1,-1,-1,0,0
19660 DATA 0,0,0,0,0,0,-1,0
19661 DATA -1,-1,-1,-1,-1,-1,-1,-1
19662 DATA 0,0,0,0,0,-1,-1,-1
19663 DATA -1,-1,-1,-1,-1,-1,-1,-1
19664 DATA -1,-1,-1,0,0,-1,-1,-1
19665 DATA -1,-1,-1,-1,-1,-1,-1,-1
19666 DATA -1,-1,-1,-1,0,-1,-1,-1
19667 DATA -1,-1,-1,-1,-1,-1,-1,-1
19668 DATA -1,-1,-1,-1,0,-1,-1,-1
19669 DATA -1,-1,-1,-1,-1,-1,-1,-1
19670 DATA -1,-1,-1,-1,0,-1,-1,-1
19671 DATA -1,-1,-1,-1,-1,-1,-1,-1
19672 DATA -1,-1,-1,-1,0,0,-1,-1
19673 DATA -1,-1,-1,-1,-1,-1,-1,-1
19674 DATA -1,-1,-1,-1,0,0,-1,-1
19675 DATA -1,-1,-1,-1,-1,-1,-1,-1
19676 DATA -1,-1,-1,0,0,0,0,-1
19677 DATA -1,-1,-1,-1,-1,-1,-1,-1
19678 DATA -1,-1,0,0,0,256,8192,5
19679 DATA 5,2,2,0,12,0,28,0
19680 DATA 44,0,0,8224,0,20560,0,8224
19681 DATA 0,0,0,8224,0,28784,0,-1800
19682 DATA 0,28784,0,8224,0,256,16384,9
19683 DATA 7,4,3,0,12,0,36,0
19684 DATA 60,0,0,2056,0,5140,0,8738
19685 DATA 0,5140,0,2056,0,0,0,2056
19686 DATA 0,7196,0,15934,0,32639,0,15934
19687 DATA 0,7196,0,2056,0,257,8192,12
19688 DATA 5,2,2,0,12,0,28,0
19689 DATA 44,0,0,2060,0,8755,0,2060
19690 DATA 0,0,0,3084,0,16191,0,-1
19691 DATA -16192,16191,0,3084,0,257,16384,20
19692 DATA 9,4,3,0,12,0,80,0
19693 DATA 148,0,0,0,0,0,-32576,0
19694 DATA 0,515,8240,0,0,2060,2060,0
19695 DATA 0,8240,515,0,0,2060,2060,0
19696 DATA 0,515,8240,0,0,0,-32576,0
19697 DATA 0,0,0,0,0,0,-16192,0
19698 DATA 0,771,-3856,0,0,3855,-772,0
19699 DATA 0,16191,-1,0,0,-1,-1,-16192
19700 DATA 0,16191,-1,0,0,3855,-772,0
19701 DATA 0,771,-3856,0,0,0,-16192,0
19702 DATA 0,545,8192,5,5,2,2,0
19703 DATA 12,0,68,0,124,0,0,0
19704 DATA 0,0,0,0,0,-2,0,0
19705 DATA 0,0,-2,0,-2,0,0,0
19706 DATA 0,-2,0,0,0,0,0,0
19707 DATA 0,0,0,0,0,-1,0,0
19708 DATA 0,0,-1,-1,-1,0,0,-1
19709 DATA -1,-1,-1,-1,0,0,-1,-1
19710 DATA -1,0,0,0,0,-1,0,0
19711 DATA 0,545,16384,9,7,4,3,0
19712 DATA 12,0,148,0,0,0,0,0
19713 DATA 0,0,0,0,0,0,0,0
19714 DATA 0,0,0,-2,0,0,0,0
19715 DATA 0,0,0,0,-2,0,-2,0
19716 DATA 0,0,0,0,0,-2,0,0
19717 DATA 0,-2,0,0,0,0,0,0
19718 DATA -2,0,-2,0,0,0,0,0
19719 DATA 0,0,0,-2,0,0,0,0
19720 DATA 0,0,0,0,0,0,0,0
19721 DATA 0,0,0,0,0,0,0,-1
19722 DATA 0,0,0,0,0,0,0,0
19723 DATA -1,-1,-1,0,0,0,0,0
19724 DATA 0,-1,-1,-1,-1,-1,0,0
19725 DATA 0,0,-1,-1,-1,-1,-1,-1
19726 DATA -1,0,0,0,0,-1,-1,-1
19727 DATA -1,-1,0,0,0,0,0,0
19728 DATA -1,-1,-1,0,0,0,0,0
19729 DATA 0,0,0,-1,0,0,0,0
19730 DATA 0,-1,-1,158,12554,12554,11569,2612
19731 DATA 12596,2609,14133,2609,12298,14602,12554,12554
19732 DATA 13322,12851,13322,12298,12554,12298,14090,13322
19733 DATA 11569,2605,12554,14090,12298,11569,2605,12554
19734 DATA 12298,14090,11569,2605,12554,13361,13322,12599
19735 DATA 13578,12598,13112,13322,12594,2608,2605,12554
19736 DATA 13361,12298,12599,12810,14346,13834,12554,12554
19737 DATA 13322,12852,12810,12554,12554,12298,14090,13322
19738 DATA 11569,2605,12554,14090,12298,11569,2605,12554
19739 DATA 12298,14090,11569,2605,12554,12598,13625,12810
19740 DATA 12598,13367,14346,9,11569,2605,12554,11569
19741 DATA 2560,-11470,2610,14346,12848,2610,2609,2608
19742 DATA 2608,2610,2613,2608,2610,14346,12848,2611
19743 DATA 14388,2609,2608,2608,2608,2611,2609,2611
19744 DATA 13616,2610,12298,13106,2609,2608,2608,2605
19745 DATA 12554,14387,2610,2609,2608,2609,2608,2605
19746 DATA 14090,11569,2605,12554,12298,12598,13360,13322
19747 DATA 12594,2608,2608,2608,2608,2608,2608,2608
19748 DATA 2608,2608,2605,12554,11569,2605,12554,12810
19749 DATA 12856,2610,12298,12810,12554,12298,12298,12810
19750 DATA 13578,12298,12856,2610,12298,12598,13622,12810
19751 DATA 12554,12298,12298,12810,13834,12554,12598,13618
19752 DATA 14346,12848,2611,12810,12554,12298,12298,12298
19753 DATA 13066,12810,12298,12298,12554,11575,2605,14346
19754 DATA 11569,2605,12554,0,9,11569,2605,12554
19755 DATA 11569,2560,0,0,0,0
19756 DATA 51834
